<?php

/* class clsDiscussion_sort */
/* ======================== */
/*        ver 0.9           */
/* ======================== */
/*  created by Petr Heller  */
/* algorithm by Jan Bulnek */
/*  http://petrheller.info  */
/* ======================== */

/* 
Tda vytvo strukturovan diskuze.
Pro diskuzi

1
-2
3
-4
 -5
 -6

se do konstruktoru vlo pole
$data[1]=0
$data[2]=1
$data[3]=0
$data[4]=3
$data[5]=4
$data[6]=4

Vstup jsou pole
$class->Order a $class->Indentation
v poli Order je poad jednotlivch pspvk jak jsou za sebou,
v poli Indentation je odsazen jednotlivch pspvk.
*/


class clsDiscussion_sort {

  function clsDiscussion_sort($dis_array) {

    global $vysl,$pocty,$N,$pred;

    $pred=$dis_array;

    $N=count($pred);

    $this->Main();

    $this->Count=$N;
    $this->Order =$vysl; //poad
    $this->Indentation =$pocty; //odsazen

  }

  function zanor($akt){

    global $pred,$poc,$por,$pocty,$vysl,$index,$N;

    //prochazeni do hloubky
    $vysl[$index++]=$akt;
    for($i=0;$i<$pocty[$akt];$i++){
      $this->zanor($por[$poc[$akt]+$i]);
    };

  }

  function Main() {

    global $pred,$poc,$por,$pocty,$vysl,$index,$N;

    //pripravi ti pomocna pole pro rekurzi
    for($i=0;$i<=$N;$i++)           //vynulovani pro jistotu
      $pocty[$i]=$por[$i]=0;

    for($i=1;$i<=$N;$i++)           //zjisteni poctu nasledniku
      $pocty[$pred[$i]]++;

    $poc[0]=0;

    for($i=1;$i<=$N;$i++)
      $poc[$i]=$poc[$i-1]+$pocty[$i-1];       //pocatky v poli

    for($i=1;$i<=$N;$i++)          //ulozeni nasledniku do pole
      $por[$poc[$pred[$i]]++]=$i;

    $poc[0]=0;

    for($i=1;$i<=$N;$i++)
      $poc[$i]=$poc[$i-1]+$pocty[$i-1];       //pocatky v poli

    $index=0;

    $this->zanor(0);

    //v tuhle chvili jsou ve vysl ulozena cisla prispevku tak jak je budes vypisovat

    //Zjisteni odsazeni;
    $pocty[0]=0;//0-ty prvek je vsude jen jakysi pomyslny a pomocny...ber ho

    // jako pocatek stromu
    for ($i=1;$i<=$N;$i++)
     $pocty[$i]=$pocty[$pred[$i]]+1;

  }
}
?>